////////////////////////////////////////////////////////////////////////////////
//
//   REC_GEN_MUD_V7.C
//
//  RECEPTOR PARA CHAVEIRINHO TRANSMISSOR COM INTEGRADO HT6P20B
//  USANDO PIC 12F675/629 PARA DECODIFICAO DOS SINAIS
//  (USA INTERRUPO DE MUDANA DE ESTADO DE GP3 E TIMER1 PARA ADQUIRIR TEMPOS)
//  COM 3 CANAIS, SENDO CONFIGURAVEL EM MODO PULSO,RETENO E TAMBM COM SADAS
//  NORMAIS OU INVERTIDAS.
//  ALTERE AS DEFINIES DE USURIOS, CONFORME A NECESSIDADE E RECOMPILE COM
//  COMPILADOR CCS C.
//
//  AUTOR:  CLUDIO LRIOS
//
//  INCIO: 07/07/2015   TRMINO: 12/07/2015
//
//
//  SUJEITO A BUGS AINDA NO OBSERVADOS EM USO. MONTAGEM REALIZADA E TESTADA
//  SOMENTE EM  PLACA DE PROTOBOARD.
//  ESTE ARQUIVO  PARTE INTEGRANTE DO BLOG LARIOS.TECNOLOGIA.WS
//==============================================================================
//                 DEFINIOES DO USURIO
//==============================================================================
//ESCOLHA DO MICROCONTROLADOR:
// Para usar o PIC12F675, descomente o abaixo e comente para usar o 12F629


      #define  F675


//==============================================================================

//==============================================================================
//  MODO DE APRENDIZADO DOS BOTES DE UM CONTROLE



 //    #define aprender_todos_botoes




//Deixe descomentado o acima p/ aprender todos os botes em uma nica operao.
// Exemplo:
// 1) Aperte boto 'learn'.
// 2) Aperte qualquer boto. Todos sero aprendidos pelo receptor e aceitos.
// Este modo dever ser usado quando temos apenas um receptor.

// Se for comentado este define, ter que aprender cada boto e tambm as suas
// possveis combinaes de acionamento .
// EX:
// 1) Aperte boto 'learn'.
// 2) Aperte um boto. Somente este ser aprendido e aceito.
// 3) Aperte outros para tambm aprende-los.
// 4) para funcionar dois ou mais botes juntos, ter que aprender com eles
//    apertados juntos, em cada possvel combinao.
//  Esta opo dever ser usada quando um controle remoto dever funcionar com
//  vrios  receptores diferentes, sendo cada tecla para um receptor.
//==============================================================================
//     NOTA IMPORTANTE  PARA OBTER O FUNCIONAMENTO DESTE SOFTWARE
//==============================================================================
// ATENO: CERTIFIQUE DE EXISTIR O BYTE DE CALIBRAO NO ENDEREO 3FFH DA FLASH
// Caso tenha sido apagado acidentalmente, ao ligar, aps a programao do pic,
// NO funcionar. O programa ir fazer um 'call'para buscar o byte de calibra-
// o, mas no encontrar a instruo de retorno 'retlw xx'. Isto far o progra-
// se perder, resetando continuamente.
// COMO SABER SE TENHO O BYTE DE CALIBRAO NO PIC?
// LENDO A FLASH COM UM PROGRAMADOR, DEVER SER ENCONTRADO NO ENDEREO 0X3FF, UM
// VALOR COMEANDO COM 34 SEGUIDO DE 2 DIGITOS. EX. 3480. (34=RETLW 80= LITERAL
// QUE SER RETORNADO EM 'W' PARA CARGA DO REGISTRADOR '0SCCAL'.



//      #define PERDI_BYTE_CALIBRACAO



//Descomente o acima se voc tem um pic que foi apagado o byte de calibrao.
//Ser substituido por valor padro que permita a operao do circuito.
//
//==============================================================================
//  MODO DE OPERAO DAS SAIDAS QUANDO SE ACIONA A RESPECTIVA TECLA NO TX
// Poder optar antes da compilao, se a sada ser 'pulso' ou 'retenao'
// Comente para 'modo pulso' e descomente para 'modo reteno'.



  //  #define  s0_ret
  //   #define  s1_ret
  //   #define  s2_ret



//==============================================================================
//  MODO DE OPERAO DAS SAIDAS INVERTIDAS OU MODO NORMAL
// Poder optar antes da compilao, se a sada ser 'pulso' ou 'retenao' com
// sadas invertidas ('1' j ao ligar o vcc e atua com '0' ao apertar boto do
// TX) ou modo normal ('0' j ao ligar vcc e atua com '1' ao apertar boto do
// tx).
// Comente para 'modo normal' e descomente para 'modo invertido'.



  //   #define  s0_invertido
  //   #define  s1_invertido
  //   #define  s2_invertido




//==============================================================================
////////////////////////////////////////////////////////////////////////////////
//
//           FIM DAS DEFINIES DO USURIO
//
//    Obs. No altere o programa a seguir, a menos que saiba o que est fazendo
//
////////////////////////////////////////////////////////////////////////////////

//==============================================================================
//
//          DEFINIES GERAIS  DO  PROGRAMA
//
//==============================================================================
#ifdef   F675
#include <12F675.h>         // includes
#else
#include <12F629.h>         // includes
#endif

#ignore_warnings 203,202  //desconsidera mensagem de 'condition always true'

#fuses INTRC_IO,NOWDT,NOPROTECT, NOMCLR ,BROWNOUT, PUT  // palavra  configurao
#use delay(clock=4000000)  // clock para 4 mhz
#use fast_io(A)  //  sentido das portas feita pelo programador

#ifdef  PERDI_BYTE_CALIBRACAO  // calibrao do oscilador interno do pic
#ROM  0X3FF = {0X34FC}//mxima freq= 0x34fc ;mdia=0x3480; minima=0x3400
#endif


//==============================================================================
//ALTERE ABAIXO, OS PINOS QUE DESEJAR COMO SADAS (SOMENTE GPIO 1,2,4,5)
// COM CUIDADO:

#bit    _s0    = 0X05.5  // PINO 2
#bit    _s1    = 0X05.1  // PINO 6
#bit    _s2    = 0X05.2  // PINO 5
#bit    _s3    = 0X05.4  // PINO 3
#bit    rfin   = 0x05.3  // PINO 4
#bit    led    = 0x05.0  // PINO 7
#bit    bot    = 0x05.0  // PINO 7
//------------------------------------------------------------------------------

//constantes
// TRIS-STATE      GPIO  543210   PINOS 2,3,4,5,6,7 -> '0' SADA E '1' ENTRADA
int8 const  TRIS_LED = 0b001000; //SENTIDO DAS PORTAS P/ ACENDER LED 'LEARN'
int8 const  TRIS_BOT = 0b001001; //SENTIDO DAS PORTAS P/ LER BOTO 'LEARN'
int8 const  qbit     = 24;//24 bits de dados
int8 const  TMAX_LED = 20;//tempo que led prog fica aceso apos aperto do botao
int8 const  TMAX_SAIDAS_LIGADAS = 20;// em modo pulso

//FLAGS GLOBAIS
int1 flag_first,flag_rok,flag_gr,flag_s0,flag_s1,flag_s2;

//REGISTRADORES GLOBAIS
int32 buffer;//buffer de recepo
int32 sbuffer;//copia do buffer para comparao de recepes
int8 botoes,qb,tl1,tl2,tm1,tm2,tm3;//registradores globais
int16   t_basico;//TEMPO BSICO

//BYTES
#byte   TRISIO = 0X85
#byte   tmr0 = 0x01
#byte   GPIO = 0X05
#byte   tmr1l= 0x0e
#byte   tmr1h= 0x0f
//BIT
#bit    tmr1_if= 0x0c.0  //flag do tmr1 over flow

#bit b6 = botoes.6
#bit b7 = botoes.7
//==============================================================================
////////////////////////////////////////////////////////////////////////////////
//
//          SUBROTINAS E FUNES  DO PROGRAMA
//
////////////////////////////////////////////////////////////////////////////////
//==============================================================================


//==============================================================================
//   INICIALIZAO DE REGISTRADORES NA RAM
//==============================================================================
void init_ram(){

   TRISIO= TRIS_LED;// ajusta trisio
   flag_rok=0;
   led=1;//desliga led

   #ifdef  s0_invertido
   _s0=1;
   #else
   _s0=0;
   #endif
  #ifdef  s1_invertido
   _s1=1;
   #else
   _s1=0;
   #endif

  #ifdef  s2_invertido
   _s2=1;
   #else
   _s2=0;
   #endif
  #ifdef  s3_invertido
   _s3=1;
   #else
   _s3=0;
   #endif

   }


//==============================================================================
//   APAGAR EEPROM
//==============================================================================
void apagar_eeprom(){ int a; for(a=0;a<128;a++) write_eeprom(a,0xff); }

//==============================================================================
//   GRAVAR  TX RECEBIDO NA EEPROM
//==============================================================================
void grava_3bytes_eeprom (int address_init, int *pont){

// onde int_addres = endereo inicial da gravao
// *pont = endereo inicial da informao (3 bytes seguidos)
 
     write_eeprom(address_init + 0,*(pont));
     write_eeprom(address_init + 1,*(pont+1));
     write_eeprom(address_init + 2,*(pont+2));
     
}

 //==============================================================================
//   LOCALIZA ENDEREO LIVRE NA EEPROM PARA GRAVAR TX RECEBIDO
//==============================================================================
int procura_3bytes_livres_eeprom () {

 int a;
   for (a=0;a<128;a+=3){  // copia buffer para sbuffer
     if(read_eeprom(a)!=0xff)continue;
     if(read_eeprom(a+1)!=0xff)continue;
     if(read_eeprom(a+2)!=0xff)continue;
     return  a;//achou 3 posies para gravar novo tx
      }
   return 0xff;//memria cheia
  }
 
//==============================================================================
//   LOCALIZA TX RECEBIDO SE GRAVADO NA EEPROM
//==============================================================================
int procura_3bytes_gravados_eeprom (int *pont) {

  int a;

  for (a=0;a<123;a+=3){  // 
     if(read_eeprom(a)!=*(pont))continue;//se diferente pula e vai para novo ciclo
     if(read_eeprom(a+1)!=*(pont +1))continue;
     if(read_eeprom(a+2)!=*(pont+2))continue;
     return  0xaa;//achou tx gravado
  }
  return 0xff;//no achou tx 
 }

//==============================================================================
//   TX RECEBIDO ENCONTRADO NA EEPROM - ACIONAR SADAS
//==============================================================================

void  acionar  (){

   if(procura_3bytes_gravados_eeprom(&buffer)==0xaa){
   tl1,tl2=0;//reseta contadores de tempo de saidas ligadas
   flag_gr=0;//reseta flag de gravao

//==============================================================================
//   ACIONAMENTOS DE SADAS EM MODO PROGRAMADO PARA 'PULSO' - HT6P20B
//==============================================================================

#ifndef s2_ret
   #ifdef s2_invertido
 if(b6&&b7) _s2=0; else _s2=1;// pino 5 '0'
   #else
 if(b6&&b7) _s2=1; else _s2=0;// pino 5 '1'
   #endif
 #endif

  #ifndef s0_ret
    #ifdef s0_invertido
 if(b7&&!b6)_s0=0; else _s0=1;// pino 2 '0'
    #else
 if(b7&&!b6)_s0=1; else _s0=0;// pino 2 '1'
    #endif
 #endif

   #ifndef s1_ret
    #ifdef s1_invertido
 if(b6&&!b7)_s1=0; else _s1=1;// pino 3 '0'
    #else
 if(b6&&!b7)_s1=1; else _s1=0;// pino 3 '1'
    #endif
 #endif

//==============================================================================
//  CHIP HT6P20B - ACIONAMENTOS DE SADAS EM MODO PROGRAMADO PARA 'RETENO'
//==============================================================================
   
   #ifdef s2_ret
   if(!flag_s2){
     if(b6&&b7){ _s2=!_s2;flag_s2=1;}
   }
   #endif
   #ifdef s0_ret
   if(!flag_s0){if(b7&&!b6){
    _s0=!_s0; flag_s0=1;  }
   }
   #endif
   #ifdef s1_ret
   if(!flag_s1){if(b6&&!b7) {
    _s1=!_s1; flag_s1=1;  }
   }
   #endif
   }

//==============================================================================
//   TESTA SE DEVE GRAVAR O TX DESCONHECIDO QUE FOI RECEBIDO
//==============================================================================
 else{
    if(flag_gr){   //gravar na eeprom o buffer
        grava_3bytes_eeprom (procura_3bytes_livres_eeprom(),&buffer);
        flag_gr=0;
       }
     }

 flag_first=0;
 flag_rok=0;  //libera nova recepo
}



//==============================================================================
////////////////////////////////////////////////////////////////////////////////
//    ROTINA DE RECPO HT6P20B (INTERRUPO POR MUDANA DE ESTADO DE GP3)
////////////////////////////////////////////////////////////////////////////////
//==============================================================================
#int_ra

VOID isr(){


  gpio&=gpio;//necessita leitura para poder setar flag de mudana de estado
  if(flag_rok||rfin){return;} //tem recepo no buffer ou mudana de estado '1'
  //rfin=0  objetivo: localizar o intervalo para sincronismo de recepo
  set_timer1(~5000);

  tmr1_if=0;//apaga flag de over flow do timer 0
  while(!tmr1_if){ if(rfin) return;}//erro


   //rfin=0
  set_timer1(~15000);

  tmr1_if=0;//apaga flag de over flow do timer 0
   while(!tmr1_if&&!rfin);//aguarda rfin se tornar '1' ou estouro do tmr1
  if(tmr1_if) return; //erro; excessivamente alto >65ms


  //rfin=1 comea o pulso bsico inicial
  set_timer1(0);
  tmr1_if=0;
  while(rfin&&!tmr1_if);//aguarda completar pulso basico inicial
  if(tmr1_if) return; //pulso 1 excessivamente alto >65ms
  //rfin=0
  t_basico=get_timer1(); // obtm o pulso bsico

 //janela de aceitao do pulso bsico inicial
  if((t_basico<200)||(t_basico>1000)) return; //erro no foi pulso basico
  qb=qbit;//ajusta quantidade de bits a receber
  buffer=0;
  do{//lao de repetio 'do'
      set_timer1(~(t_basico/2));
      tmr1_if=0;
      while(!tmr1_if);
      //rfin tem que ser '0'
      if(rfin) return;//erro
      set_timer1(~(t_basico));
      tmr1_if=0;
      while(!tmr1_if);
      //rfin poder ser '0' ou '1'
       buffer>>=1;
      if(!rfin)buffer|=0x00800000;
      

      set_timer1(~(t_basico));
      tmr1_if=0;
      while(!tmr1_if);
      //rfin tem que ser '1'
      if(!rfin){return;}//erro

      set_timer1(~(t_basico));
      tmr1_if=0;
      while(!tmr1_if&&rfin);//aguarda entrada rfin ficar '0'
      if(tmr1_if) return; //erro; excessivamente alto >65ms
      //rfin=0;
  }while(--qb);//recebe todos os 24 bits do tx

        botoes= buffer>>16;
        #ifdef aprender_todos_botoes
        buffer&=0xff3fffff;//apaga botes
        #endif
        flag_rok=1;//tem uma recepo no buffer aguardando ser tratada

}//VOID isr()



//==============================================================================
//   FIM   DA   ROTINA DE INTERRUPO DO TIMER 0
//==============================================================================

//==============================================================================
///////////////////////////////////////////////////////////////////////////////
//                    ROTINA PRINCIPAL
////////////////////////////////////////////////////////////////////////////////
//==============================================================================

//==============================================================================
//   INICIALIZAO DE PORTAS E REGISTRADORES
//==============================================================================

void main(){
   #ifdef  F675
   setup_adc_ports(no_analogs);  //somente pic12f675
   SETUP_ADC(ADC_OFF); //DESLIGA ADC
   #endif
   setup_comparator(nc_nc_nc_nc); // desliga comparadores
   setup_counters (RTCC_INTERNAL,RTCC_DIV_1);   //timer 0
   setup_timer_1 ( T1_INTERNAL | T1_DIV_BY_1 );
   ENABLE_INTERRUPTS(INT_RA3); // liga interrupo por mudana
   enable_interrupts(GLOBAL);   //  liga interrupo geral
   PORT_A_PULLUPS(TRUE);
   init_ram();
//==============================================================================
//   LOOP  PRINCIPAL DE REPETIO
//==============================================================================

   while (TRUE) {

    int a;


//==============================================================================
//   TESTA BOTO 'LEARN' SE FOI APERTADO
//==============================================================================

       TRISIO= TRIS_BOT;// ajusta trisio
       if(!bot){
            tm3=0;    //reseta contadores de apagamento do led 'learn' em
            tm2=0;    //modo de gravao de tx
            tm1=0;
            flag_gr=1; //aciona flag p/ gravao (ir ligar led 'learn')
            for (a=0;!bot;a++) {
               delay_ms(50);
               if(a==100){
                  apagar_eeprom();
                  flag_gr=0;
                  TRISIO= TRIS_LED;// ajusta trisio=saida p/ led
                  for(a=0;a<5;a++){
                     LED=0;
                     delay_ms(250);
                     LED=1;
                     delay_ms(250);
                     }
                   break;
                  }
            }
        }
 //=============================================================================
 // liga led 'learn' em modo de gravao de TX
 //=============================================================================
       TRISIO= TRIS_LED;// ajusta trisio=saida p/ led
       if(flag_gr){
         LED=0;
       }
       else
       {
         LED=1;
       }
//==============================================================================
//         DESCARTA RECEPO FFFFFF
//==============================================================================
      if(!flag_first && flag_rok){
         if (buffer==0xffffff){
            flag_rok=0;
           }
      }
 //==============================================================================
//         DESCARTA RECEPO 000000
//==============================================================================
       if(!flag_first && flag_rok){
         if (buffer==0x00){
            flag_rok=0;
           }
      }


//==============================================================================
//   SALVA A PRIMEIRA RECEPO PARA PODER COMPARAR COM A PRXIMA
//==============================================================================

        if(!flag_first && flag_rok){
      sbuffer=buffer; //salva a primeira recepo
      buffer=0;
      flag_first=1;  //seta bit de primeira recepo
      flag_rok=0;
      }
//==============================================================================
//   COMPARA A PRIMEIRA RECEPO COM A SEGUNDA - ACIONA SE IGUAIS
//==============================================================================

      if(flag_first && flag_rok ){
      if(buffer==sbuffer) {
             acionar();  //temos uma recepo correta, acionar sadas
             }
         
      flag_first=0;  //zera bit de primeira recepo
      flag_rok=0;
     }
//==============================================================================
//



//==============================================================================
//     TEMPO QUE FICA ACESO O LED LEARN AO APERTAR BOTO LEARN
//==============================================================================

   if(++tm1==0){ if(++tm2==0) { if(++tm3>=TMAX_LED) flag_gr=0; } }

//==============================================================================
//     TEMPO PARA DESLIGAMENTO DAS SAIDAS
//==============================================================================

     if(++tl1==0){ if(++tl2==TMAX_SAIDAS_LIGADAS) { tl2=0; tl1=0;

//==============================================================================
//   DESLIGA AS SADAS EM MODO PROGRAMADO PARA 'PULSO'
//==============================================================================

         #ifndef s0_ret
            #ifdef  s0_invertido
            _s0=1;
            #else
            _s0=0; //desliga s0 em modo pulso
            #endif
         #endif

         #ifndef s1_ret
            #ifdef  s1_invertido
            _s1=1;
            #else
            _s1=0; //desliga s0 em modo pulso
            #endif
         #endif

         #ifndef s2_ret
            #ifdef  s2_invertido
            _s2=1;
            #else
            _s2=0; //desliga s0 em modo pulso
            #endif
         #endif
         #ifndef s3_ret
            #ifdef  s3_invertido
            _s3=1;
            #else
            _s3=0; //desliga s0 em modo pulso
            #endif
         #endif


//==============================================================================
//   RESETA OS FLAGS DAS SADAS EM MODO PROGRAMADO PARA 'RETENO'
//==============================================================================


         #ifdef  s0_ret
          flag_s0=0; //desliga flag_s0 em modo reteno
         #endif
         #ifdef  s1_ret
         flag_s1=0;//desliga flag_s1 em modo reteno
         #endif
         #ifdef  s2_ret
         flag_s2=0;//desliga flag_s2 em modo reteno
         #endif
         #ifdef  s3_ret
         flag_s3=0;//desliga flag_s3 em modo reteno
         #endif
         }
      }




//==============================================================================
   }// while (TRUE)
}//void main()

